import React from 'react';
type RenderFn = (key: string, children: () => React.ReactChild | JSX.Element | null, container: HTMLElement) => void;
type RemoveFn = (key: string) => void;
interface PortalProviderAPI {
    render: RenderFn;
    remove: RemoveFn;
    destroy: () => void;
}
type PortalRendererComponent = () => JSX.Element;
type UsePortalProviderReturnType = [
    PortalProviderAPI,
    PortalRendererComponent
];
/**
 * Initializes PortalManager and creates PortalRendererComponent. Offers an API (portalProviderAPI) for managing portals.
 * @returns {[PortalProviderAPI, PortalRendererComponent]} An array containing two elements:
 *         1. portalProviderAPI: An object providing an API for rendering and removing portals.
 *         2. PortalRenderer: A React component responsible for rendering the portal content.
 */
export declare function usePortalProvider(): UsePortalProviderReturnType;
export {};
